<template>
  <template v-if="examples.length > 0">
    <section v-for="example in examples" :key="example" class="-mtl">
      <h2>{{ titleize(example) }}</h2>

      <doc-example-renderer :file="example" :file-type="fileType" />
    </section>
  </template>
  <rui-empty v-else content="No example found" />
</template>

<script>
import { RuiEmpty } from '../../../src/components/index.js'
import DocExampleRenderer from '../../components/ExampleRenderer/ExampleRenderer.vue'

export default {
  name: 'ComponentExamplesView',
  components: { RuiEmpty, DocExampleRenderer },
  data () {
    return {
      examples: [],
      fileType: null,
    }
  },
  methods: {
    initialize () {
      const fileType = this.$route.meta.fileType
      const examples = this.$getDoc(this.$route.params.component).examples[fileType]
      if (!fileType || examples.length === 0) { this.$router.push({ name: '404error' }) }

      this.fileType = fileType
      this.examples = examples
    },
    titleize (string) {
      string = string.replace(/.*\.example\.\d?/, '')
        .replace(/[-_.]/g, ' ')
        .trim()
      return `${string.charAt(0).toUpperCase()}${string.substring(1)}`
    },
  },
  created () {
    this.initialize()
  },
  watch: {
    $route (newValue) {
      // Ignore routes that don't include this component
      if (!['doc-vue', 'doc-html'].includes(newValue.name)) return

      this.initialize()
    },
  },
}
</script>
